#!/bin/sh

ksmroot=${ksmroot:-"/adds/kbmenu"}
ksmuser=${ksmuser:-"/mnt/onboard/.adds/kbmenu_user"}
ksmFontDir=${ksmFontDir:-"$ksmroot/fonts"}

[ -d "$ksmFontDir" ] || ksmFontDir="$ksmroot/fonts"

if [ "$KSMdebugmode" == "true" ]; then
#debug_logfile=$ksmroot/log/ksmdebug_$(date +%Y%m%d_%H%M%S)_kobomenu.sh.log
  debug_logfile=$ksmroot/log/ksmdebug_$(date +%Y%m%d_%H%M%S)_$(basename $0).log
  echo "started: $(date +%Y%m%d_%H%M%S)" > $debug_logfile
  echo "script path: $0" >> $debug_logfile
  echo "ksmroot: $ksmroot" >> $debug_logfile
  echo "ksmuser: $ksmuser" >> $debug_logfile
  echo "ksmFontDir: $ksmFontDir" >> $debug_logfile
  echo "product: $PRODUCT" >> $debug_logfile
  echo "ksmGeometryValuesN: $ksmGeometryValuesN"  >> $debug_logfile
  echo "ksmGeometryValuesE: $ksmGeometryValuesE"  >> $debug_logfile
  echo "ksmGeometryValuesS: $ksmGeometryValuesS"  >> $debug_logfile
  echo "ksmGeometryValuesW: $ksmGeometryValuesW"  >> $debug_logfile
  sync
fi


export QT_PLUGIN_PATH=$ksmroot/Qt/plugins
export LD_LIBRARY_PATH=$ksmroot/Qt/lib
export QWS_MOUSE_PROTO=KoboTS
export QT_QWS_FONTDIR=$ksmFontDir
#export QWS_KEYBOARD=KoboKb


if [ "$mrotation" == "0" ] || [ "$mrotation" == "90" ] || [ "$mrotation" == "180" ] || [ "$mrotation" == "270" ]; then
  export QWS_DISPLAY=Transformed:KoboFB:Rot$mrotation
else
  export QWS_DISPLAY=Transformed:KoboFB:Rot90
fi


if [ "$mrotation" == "0" ] && [ "x$ksmGeometryValuesE" != "x" ]; then
  moption=$($ksmroot/kobomenu $* -qws -geometry $ksmGeometryValuesE)
elif [ "$mrotation" == "90" ] && [ "x$ksmGeometryValuesN" != "x" ]; then
  moption=$($ksmroot/kobomenu $* -qws -geometry $ksmGeometryValuesN)
elif [ "$mrotation" == "180" ] && [ "x$ksmGeometryValuesW" != "x" ]; then
  moption=$($ksmroot/kobomenu $* -qws -geometry $ksmGeometryValuesW)
elif [ "$mrotation" == "270" ] && [ "x$ksmGeometryValuesS" != "x" ]; then
  moption=$($ksmroot/kobomenu $* -qws -geometry $ksmGeometryValuesS)
else
  moption=$($ksmroot/kobomenu $* -qws)
fi

[ "$KSMdebugmode" == "true" ] && echo "moption: $moption" >> $debug_logfile
echo "$moption"
